from unittest import TestCase

import os
import libevdev

class TouchpadTest(TestCase):
    LANGUAGES = {
        'zh': {
            'TouchpadTest': '触摸板',
            'test_enumerate_device': '枚举设备'
        },
        'en': {
            'TouchpadTest': 'Touchpad',
            'test_enumerate_device': 'Enumerate device'
        }
    }

    def test_enumerate_device(self):
        inputs = os.listdir('/dev/input')
        events = [f for f in inputs if f.startswith('event')]

        self.assertIsNotNone(events)

        found = False
        for event in events:
            path = f'/dev/input/{event}'
            try:
                with open(path, 'rb') as f:
                    dev = libevdev.Device(f)
                    if dev.has(libevdev.EV_ABS.ABS_MT_TRACKING_ID):
                        found = True
                        break
            except:
                self.fail(f'Handle {path} fail')

        if not found:
            self.fail('Not touchpad found')
