from unittest import TestCase

import subprocess

class HDMITest(TestCase):
    LANGUAGES = {
        'zh': {
            'HDMITest': 'HDMI',
            'test_hdmi': '显示彩色条纹，播放一段音乐'
        },
        'en': {
            'HDMITest': 'HDMI',
            'test_hdmi': 'Display colorbar, play a piece of music'
        }
    }

    def test_hdmi(self):
        try:
            cmd = 'modetest -M spacemit -D /dev/dri/card2 -s 130@127:1920x1080 -a -P 31@127:1920x1080+0+0@AR24'
            colorbar_proc = subprocess.Popen(cmd, shell=True,
                                             start_new_session=True,
                                             stdout=subprocess.PIPE,
                                             stderr=subprocess.PIPE)
            # avoid modetest not start
            # FIXME
            print(colorbar_proc.stderr.readline().decode())

            music_file = '/opt/factorytest/res/canon.wav'
            cmd = f'aplay -Dhw:0,0 -r 48000 -f S16_LE {music_file}'
            audio_proc = subprocess.Popen(cmd, shell=True,
                                          start_new_session=True,
                                          stdout=subprocess.PIPE,
                                          stderr=subprocess.PIPE)
        except:
            self.fail('Create subprocess fail')
